-- IncHeal for RIFT by Vritra@Wolfsbane 2012-2013.

--local GREEN = {.2,.5,.2,.4}	-- {red, green, blue, alpha} 0.00 to 1.00.
local GOLD = {.9,.75,.6,1}
local BLACK = {0,0,0,.5}
local F = {}
local PLAYERID = Inspect.Unit.Lookup("player")
--local BARIMAGE = "bar1.png"	-- bar image ex
local BARIMAGE = "bar.png"

table.insert(Event.Addon.Load.End, {function(addon)
	if addon == "IncHeal" then
		Context = UI.CreateContext("IncHeal")

		F.TGFrame = UI.CreateFrame("Texture", "TargetFrame", Context)
		F.TGFrame:SetVisible(false)
		F.TGFrame:SetLayer(1)
		F.TGFrame:SetTexture("IncHeal", BARIMAGE)
		F.TGFrame.parent = UI.Native.PortraitTarget
		F.TGFrame.lookup = "player.target"
		F.TGFrame.result = {}
		F.TGFrame.t = .32	--ue kara no kyori
		F.TGFrame.l = -.006	--hidari haji kara no kyori
		F.TGFrame.h = .054	--bar takasa
		F.TGFrame.text = UI.CreateFrame("Text", "TargetFrameText", F.TGFrame)
		F.TGFrame.text:SetPoint(0,.7, F.TGFrame, 0,0)
		F.TGFrame.text:SetFontColor(unpack(GOLD))
		F.TGFrame.text:SetLayer(3)
		F.TGFrame.tsdw = UI.CreateFrame("Text", "TargetFrameTextShadow", F.TGFrame)
		F.TGFrame.tsdw:SetPoint(0,.7, F.TGFrame, 0,0 ,1, 1)
		F.TGFrame.tsdw:SetFontColor(unpack(BLACK))
		F.TGFrame.tsdw:SetLayer(2)

		F.PCFrame = UI.CreateFrame("Texture", "PlayerFrame", Context)
		F.PCFrame:SetVisible(false)
		F.PCFrame:SetTexture("IncHeal", BARIMAGE)
		F.PCFrame:SetLayer(1)
		F.PCFrame.parent = UI.Native.PortraitPlayer
		F.PCFrame.lookup = "player"
		F.PCFrame.result = {}
		F.PCFrame.t = .38
		F.PCFrame.l = .412
		F.PCFrame.h = .065
		F.PCFrame.text = UI.CreateFrame("Text", "PlayerFrameText", F.PCFrame)
		F.PCFrame.text:SetPoint(0,.7, F.PCFrame, 0,0)
		F.PCFrame.text:SetFontColor(unpack(GOLD))
		F.PCFrame.text:SetLayer(3)
		F.PCFrame.tsdw = UI.CreateFrame("Text", "PlayerFrameTextShadow", F.PCFrame)
		F.PCFrame.tsdw:SetPoint(0,.7, F.PCFrame, 0,0, 1, 1)
		F.PCFrame.tsdw:SetFontColor(unpack(BLACK))
		F.PCFrame.tsdw:SetLayer(2)

		F.TTFrame = UI.CreateFrame("Texture", "TargetTargetFrame", Context)
		F.TTFrame:SetVisible(false)
		F.TTFrame:SetTexture("IncHeal", BARIMAGE)
		F.TTFrame:SetLayer(1)
		F.TTFrame.parent = UI.Native.PortraitTargetTarget
		F.TTFrame.lookup = "player.target.target"
		F.TTFrame.result = {}
		F.TTFrame.t = .32
		F.TTFrame.l = -.003
		F.TTFrame.h = .054
		F.TTFrame.text = UI.CreateFrame("Text", "TargetTargetFrameText", F.TTFrame)
		F.TTFrame.text:SetPoint(0,.7, F.TTFrame, 0,0)
		F.TTFrame.text:SetFontColor(unpack(GOLD))
		F.TTFrame.text:SetLayer(3)
		F.TTFrame.tsdw = UI.CreateFrame("Text", "TargetTargetFrameTextShadow", F.TTFrame)
		F.TTFrame.tsdw:SetPoint(0,.7, F.TTFrame, 0,0, 1, 1)
		F.TTFrame.tsdw:SetFontColor(unpack(BLACK))
		F.TTFrame.tsdw:SetLayer(2)

		F.FCFrame = UI.CreateFrame("Texture", "FocusFrame", Context)
		F.FCFrame:SetVisible(false)
		F.FCFrame:SetTexture("IncHeal", BARIMAGE)
		F.FCFrame:SetLayer(1)
		F.FCFrame.parent = UI.Native.PortraitFocus
		F.FCFrame.lookup = "focus"
		F.FCFrame.result = {}
		F.FCFrame.t = .32
		F.FCFrame.l = -.006
		F.FCFrame.h = .06
		F.FCFrame.text = UI.CreateFrame("Text", "FocusFrameText", F.FCFrame)
		F.FCFrame.text:SetPoint(0,.7, F.FCFrame, 0,0)
		F.FCFrame.text:SetFontColor(unpack(GOLD))
		F.FCFrame.text:SetLayer(3)
		F.FCFrame.tsdw = UI.CreateFrame("Text", "FocusFrameTextShadow", F.FCFrame)
		F.FCFrame.tsdw:SetPoint(0,.7, F.FCFrame, 0,0, 1, 1)
		F.FCFrame.tsdw:SetFontColor(unpack(BLACK))
		F.FCFrame.tsdw:SetLayer(2)
	end
end, "IncHeal", "OnLoadEnd"})

table.insert(Event.Unit.Castbar, {function(units)
	for unitid, visibleFlag in pairs(units) do
		if visibleFlag then
			local cb = Inspect.Unit.Castbar(unitid) or false
			if cb and cb.abilityNew then
				local ad = Inspect.Ability.New.Detail(cb.abilityNew) or false
				if ad and ad.description and ad.target then
					local arg = {}
					local i = 1
					for word in string.gmatch(ad.description, "[^%s]+") do
						arg[i] = word
						i = i + 1
						if i > 2 then break end
					end
					local healValue = 0
					-- "Heal spell" detect from Tool tips
					if (arg[1] == "Restores" or arg[1] == "Stellt" or arg[1] == "Restaure") and tonumber(arg[2]) then
						healValue = tonumber(arg[2])
						detail = Inspect.Unit.Detail(ad.target) or false
						if detail and detail.health and detail.healthMax then
							for fs in pairs(F) do
								f = F[fs]
								local targetID = Inspect.Unit.Lookup(f.lookup)
								if ad.target == targetID and f.parent:GetLoaded() then
									local gh, gw = f.parent:GetHeight(), f.parent:GetWidth()
									local l = f.l+((gw*.544)/gw*((detail.health/detail.healthMax*100)/100))
									local h = math.floor(gh*f.h)
									local resultSum = 0
									for a, b in pairs(f.result) do resultSum = resultSum + b end
									local w = math.floor((gw*.544)*(((healValue+resultSum)/detail.healthMax*100)/100))
									f:ClearAll()
									f:SetPoint(0,0, f.parent, l,f.t)
									f:SetHeight(h)
									f:SetWidth(w)
									f:SetVisible(true)
									f.result[unitid] = healValue
									f.text:SetText(arg[2])
									f.tsdw:SetText(arg[2])
									local fontSize = h-- - 1
									f.text:SetFontSize(fontSize)
									f.tsdw:SetFontSize(fontSize)
								end
							end
						end
					end
				end
			end
		else
			for fs in pairs(F) do
				local f = F[fs]
				if f and unitid and f.result[unitid] then f.result[unitid] = 0 end
				local resultSum = 0
				for a, b in pairs(f.result) do resultSum = resultSum + b end
				if resultSum < 1 then
					f:SetVisible(false)
					f.result = {}
				end
			end
		end
	end
end, "IncHeal", "OnCastbar"})

table.insert(Event.Ability.New.Target, {function()
	F.TGFrame:SetVisible(false)
	F.TTFrame:SetVisible(false)
end, "IncHeal", "OnTarget"})

local function OnHealth(unit)
	for unitId in pairs(unit) do
		local detail = Inspect.Unit.Detail(unitId)
		if detail and detail.health and detail.healthMax then
			for fs in pairs(F) do
				local f = F[fs]
				if f.result[unitId] then
					local gw = f.parent:GetWidth()
					local l = f.l+((gw*.544)/gw*((detail.health/detail.healthMax*100)/100))
					f:SetPoint(0,0, f.parent, l,f.t)
				end
			end
		end
	end
end
table.insert(Event.Unit.Detail.Health, {OnHealth, "IncHeal", "OnHP"})
table.insert(Event.Unit.Detail.HealthMax, {OnHealth, "IncHeal", "OnMaxHP"})